// QQPlay window need to be inited first
if (false) {
    BK.Script.loadlib('GameRes://libs/qqplay-adapter.js');
}

window.boot = function () {
    var settings = window._CCSettings;
    window._CCSettings = undefined;

    if ( !settings.debug ) {
        var uuids = settings.uuids;

        var rawAssets = settings.rawAssets;
        var assetTypes = settings.assetTypes;
        var realRawAssets = settings.rawAssets = {};
        for (var mount in rawAssets) {
            var entries = rawAssets[mount];
            var realEntries = realRawAssets[mount] = {};
            for (var id in entries) {
                var entry = entries[id];
                var type = entry[1];
                // retrieve minified raw asset
                if (typeof type === 'number') {
                    entry[1] = assetTypes[type];
                }
                // retrieve uuid
                realEntries[uuids[id] || id] = entry;
            }
        }

        var scenes = settings.scenes;
        for (var i = 0; i < scenes.length; ++i) {
            var scene = scenes[i];
            if (typeof scene.uuid === 'number') {
                scene.uuid = uuids[scene.uuid];
            }
        }

        var packedAssets = settings.packedAssets;
        for (var packId in packedAssets) {
            var packedIds = packedAssets[packId];
            for (var j = 0; j < packedIds.length; ++j) {
                if (typeof packedIds[j] === 'number') {
                    packedIds[j] = uuids[packedIds[j]];
                }
            }
        }

        var subpackages = settings.subpackages;
        for (var subId in subpackages) {
            var uuidArray = subpackages[subId].uuids;
            if (uuidArray) {
                for (var k = 0, l = uuidArray.length; k < l; k++) {
                    if (typeof uuidArray[k] === 'number') {
                        uuidArray[k] = uuids[uuidArray[k]];
                    }
                }
            }
        }
    }

    function setLoadingDisplay () {
        // Loading splash scene
        var splash = document.getElementById('splash');
        var progressBar = splash.querySelector('.progress-bar span');
        cc.loader.onProgress = function (completedCount, totalCount, item) {
            var percent = 100 * completedCount / totalCount;
            if (progressBar) {
                progressBar.style.width = percent.toFixed(2) + '%';
            }
        };
        splash.style.display = 'block';
        progressBar.style.width = '0%';

        cc.director.once(cc.Director.EVENT_AFTER_SCENE_LAUNCH, function () {
            splash.style.display = 'none';
        });
    }

    var onStart = function () {
        cc.loader.downloader._subpackages = settings.subpackages;

        cc.view.enableRetina(true);
        cc.view.resizeWithBrowserSize(true);

        if (!false && !false) {
            if (cc.sys.isBrowser) {
                setLoadingDisplay();
            }

            if (cc.sys.isMobile) {
                if (settings.orientation === 'landscape') {
                    cc.view.setOrientation(cc.macro.ORIENTATION_LANDSCAPE);
                }
                else if (settings.orientation === 'portrait') {
                    cc.view.setOrientation(cc.macro.ORIENTATION_PORTRAIT);
                }
                cc.view.enableAutoFullScreen([
                    cc.sys.BROWSER_TYPE_BAIDU,
                    cc.sys.BROWSER_TYPE_WECHAT,
                    cc.sys.BROWSER_TYPE_MOBILE_QQ,
                    cc.sys.BROWSER_TYPE_MIUI,
                ].indexOf(cc.sys.browserType) < 0);
            }

            // Limit downloading max concurrent task to 2,
            // more tasks simultaneously may cause performance draw back on some android system / browsers.
            // You can adjust the number based on your own test result, you have to set it before any loading process to take effect.
            if (cc.sys.isBrowser && cc.sys.os === cc.sys.OS_ANDROID) {
                cc.macro.DOWNLOAD_MAX_CONCURRENT = 2;
            }
        }

        function loadScene(launchScene) {
            cc.director.loadScene(launchScene, null,
                function () {
                    if (cc.sys.isBrowser) {
                        // show canvas
                        var canvas = document.getElementById('GameCanvas');
                        canvas.style.visibility = '';
                        var div = document.getElementById('GameDiv');
                        if (div) {
                            div.style.backgroundImage = '';
                        }
                    }
                    cc.loader.onProgress = null;
                    if (cc.sys.os === cc.sys.OS_ANDROID) { 
                        // jsb.reflection.callStaticMethod('org/cocos2dx/javascript/AppActivity', 'removeLaunchImage',  '()V'); 
                    }
                }
            );

        }

        var launchScene = settings.launchScene;

        // load scene
        loadScene(launchScene);

    };

    // jsList
    var jsList = settings.jsList;

    if (false) {
        BK.Script.loadlib();
    }
    else {
        var bundledScript = settings.debug ? 'src/project.dev.js' : 'src/project.js';
        if (jsList) {
            jsList = jsList.map(function (x) {
                return 'src/' + x;
            });
            jsList.push(bundledScript);
        }
        else {
            jsList = [bundledScript];
        }
    }
    
    var option = {
        id: 'GameCanvas',
        scenes: settings.scenes,
        debugMode: settings.debug ? cc.debug.DebugMode.INFO : cc.debug.DebugMode.ERROR,
        showFPS: !false && settings.debug,
        frameRate: 60,
        jsList: jsList,
        groupList: settings.groupList,
        collisionMatrix: settings.collisionMatrix,
    }

    // init assets
    cc.AssetLibrary.init({
        libraryPath: 'res/import',
        rawAssetsBase: 'res/raw-',
        rawAssets: settings.rawAssets,
        packedAssets: settings.packedAssets,
        md5AssetsMap: settings.md5AssetsMap,
        subpackages: settings.subpackages
    });

    cc.game.run(option, onStart);
};

// main.js is qqplay and jsb platform entry file, so we must leave platform init code here
if (false) {
    BK.Script.loadlib('GameRes://src/settings.js');
    BK.Script.loadlib();
    BK.Script.loadlib('GameRes://libs/qqplay-downloader.js');

    var ORIENTATIONS = {
        'portrait': 1,
        'landscape left': 2,
        'landscape right': 3
    };
    BK.Director.screenMode = ORIENTATIONS[window._CCSettings.orientation];
    initAdapter();
    cc.game.once(cc.game.EVENT_ENGINE_INITED, function () {
        initRendererAdapter();
    });

    qqPlayDownloader.REMOTE_SERVER_ROOT = "";
    var prevPipe = cc.loader.md5Pipe || cc.loader.assetLoader;
    cc.loader.insertPipeAfter(prevPipe, qqPlayDownloader);
    
    window.boot();
}
else if (window.jsb) {
    // console.log( 'mycold main.js begin ============');

    // let restart = false;
    // window.globalCold = {};
    // window.globalCold.localV = undefined;
    // window.globalCold.cacheV = undefined;
    // window.globalCold.netV = undefined;
    // try{
    //     var versionCompare = function (versionA, versionB) {
    //         console.log("mycold Custom Version Compare: version local is " + versionA + ', version catch is ' + versionB);
    //         var vA = versionA.split('.');
    //         var vB = versionB.split('.');
    //         for (var i = 0; i < vA.length; ++i) {
    //             var a = parseInt(vA[i]);
    //             var b = parseInt(vB[i] || 0);
    //             if (a === b) {
    //                 continue;
    //             }
    //             else {
    //                 return a - b;
    //             }
    //         }
    //         if (vB.length > vA.length) {
    //             return -1;
    //         }
    //         else {
    //             return 0;
    //         }
    //     };
    //
    //     var searchPaths = jsb.fileUtils.getSearchPaths();
    //     if(searchPaths && (searchPaths.length ==1 || searchPaths.length == 3)){
    //         // console.log('mycold searchPaths ' + JSON.stringify(searchPaths));
    //     } else {
    //         console.log('mycold searchPaths count error!!! :  '+JSON.stringify(searchPaths));
    //     }
    //     if(searchPaths && searchPaths.length > 0){
    //         console.log( 'mycold new searchPaths count: '+searchPaths.length);
    //         searchPaths.forEach((v,i)=>{
    //             console.log( 'mycold searchPaths: ',i,v);
    //         });
    //     } else {
    //         console.log( 'mycold searchPaths count: 0');
    //     }
    //
    //     // cache
    //     // jsb.fileUtils.getWritablePath() + 'my-remote-asset/' + project.manifest
    //     // app
    //     // getItem('my-own-folder') + getItem('my-own-project-name')
    //     // res/raw-assets/16/ + 16fdd021-f82d-4565-b3a8-e5875999c3af.manifest
    //     // root path
    //     // var searchPaths = jsb.fileUtils.getSearchPaths();
    //     // searchPaths[searchPaths.length -1]
    //     let cacheFolder = jsb.fileUtils.getWritablePath();
    //     let cacheProjectName = 'project.manifest';
    //     let owndFolder = localStorage.getItem('my-own-folder');// res/raw-assets/16/
    //     let ownProjectName = localStorage.getItem('my-own-project-name');// 16fdd021-f82d-4565-b3a8-e5875999c3af.manifest
    //     if(owndFolder) {
    //         let assets = searchPaths[searchPaths.length -1];
    //         console.log('mycold cache path: ',cacheFolder + 'my-remote-asset/');
    //         // console.log('mycold cache path: ',cacheProjectName);
    //         console.log('mycold app path: ',assets + owndFolder);
    //         // console.log('mycold app path 2: ',ownProjectName);
    //         console.log('mycold root path: ',assets);
    //         let newSearchPaths = [cacheFolder + 'my-remote-asset/',assets + owndFolder,assets];
    //         jsb.fileUtils.setSearchPaths(newSearchPaths);
    //         // let catchPath = cacheFolder + 'my-remote-asset/' + cacheProjectName;
    //         let catchPath = cacheProjectName;
    //         let ownPath = ownProjectName;
    //         let cacheObj = undefined;
    //         let ownObj = undefined;
    //         if(jsb.fileUtils.isFileExist(catchPath)){
    //             cacheObj =  JSON.parse(jsb.fileUtils.getStringFromFile(catchPath));
    //             // console.log('mycold cacheObj',JSON.stringify(cacheObj));
    //             window.globalCold.cacheV = cacheObj.version;
    //         }
    //         if(jsb.fileUtils.isFileExist(ownPath)){
    //             ownObj =  JSON.parse(jsb.fileUtils.getStringFromFile(ownPath));
    //             window.globalCold.localV = ownObj.version;
    //             // console.log('mycold ownObj',JSON.stringify(ownObj));
    //         }
    //         if(ownObj && cacheObj){
    //             let ret = versionCompare(ownObj.version,cacheObj.version);
    //             if(ret > 0){
    //                 restart = true;
    //             }
    //         } else if(cacheObj){
    //             console.log('mycold error!!! : No local version');
    //         }
    //
    //         if(!restart){
    //             // console.log('mycold new setSearchPaths ' + JSON.stringify(newSearchPaths));
    //             jsb.fileUtils.setSearchPaths(newSearchPaths);
    //             if(newSearchPaths && newSearchPaths.length > 0){
    //                 console.log( 'mycold main new searchPaths count: '+newSearchPaths.length);
    //                 newSearchPaths.forEach((v,i)=>{
    //                     console.log( 'mycold main new searchPaths: ',i,v);
    //                 });
    //             } else {
    //                 console.log( 'mycold main new searchPaths count: 0');
    //             }
    //         } else {
    //             console.log( 'mycold remove cache: ',cacheFolder + 'my-remote-asset/');
    //             // loacl最新
    //             jsb.fileUtils.removeDirectory(cacheFolder + 'my-remote-asset/');
    //             jsb.fileUtils.setSearchPaths(searchPaths);
    //         }
    //     }
    // } catch(err){
    //     console.error("error:", "mycold " + JSON.stringify(err));
    // }
    // console.log( 'mycold main.js end ============');


    var isRuntime = (typeof loadRuntime === 'function');
    if (isRuntime) {
        require('src/settings.js');
        require('src/cocos2d-runtime.js');
        require('jsb-adapter/engine/index.js');
    }
    else {
        require('src/settings.js');
        require('src/cocos2d-jsb.js');
        require('jsb-adapter/jsb-engine.js');
    }
    // if(restart){
    //     console.log('mycold del catch, cc.game.restart');
    //     cc.game.restart();
    // }
    cc.macro.CLEANUP_IMAGE_CACHE = true;
    window.boot();
}